#include "DeerStudio/EditorEngine/API/EditorEngine_Icon.h"
#include "DeerStudio/EditorEngine.h"
#include "DeerStudio/EditorEngine/DockPanelObject.h"
#include "Deer/Log.h"
#include "Deer/DataStore.h"
#include "imgui.h"

namespace Deer {
    namespace EditorEngine {
        void drawIcon(std::string& name, int size) {
            int iconId = DataStore::getIconId(name);

            if (iconId < 0) {
                DEER_UI_ENGINE_ERROR("Invalid icon name {0}", name.c_str());
                if (currentDockPanelExecution) {
                    currentDockPanelExecution->invalidate();
                }
                return;
            }

            ImGui::Image((void*)(uint64_t)iconId,
            ImVec2(size, size), ImVec2(0, 1),
            ImVec2(1, 0));
        }

        void drawIconCentered(std::string& name, int size) {
            int iconId = DataStore::getIconId(name);
            if (iconId < 0) {
                DEER_UI_ENGINE_ERROR("Invalid icon name {0}", name.c_str());
                if (currentDockPanelExecution) {
                    currentDockPanelExecution->invalidate();
                }
                return;
            }

            float sizeX;
            if (ImGui::GetColumnsCount() > 1)
                sizeX = ImGui::GetColumnWidth(-1);
            else
                sizeX = ImGui::GetContentRegionAvail().x;
        
            float iconWidth = size;
            float padding = (sizeX - iconWidth) * 0.5f;

            if (padding > 0.0f)
                ImGui::SetCursorPosX(ImGui::GetCursorPosX() + padding);
                
            drawIcon(name, size);
        }
    }
}