#include "DeerStudio/EditorEngine/API/EditorEngine_Functions.h"
#include "DeerStudio/EditorEngine.h"
#include "DeerStudio/EditorEngine/EditorEngine_ErrorHandle.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Button.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Column.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Directory.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Environment.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Environment.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Functions.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Functions.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Icon.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Input.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Mesh.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_Text.h"
#include "DeerStudio/EditorEngine/API/EditorEngine_MenuBar.h"

#include "angelscript.h"

namespace Deer {
    void EditorEngine::registerEditorEngineFunctions() {
        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "bool menuItem(const string& in)",
            asFUNCTION(Deer::EditorEngine::menuItem),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void textColor(float, float, float, const string& in)",
            asFUNCTION(Deer::EditorEngine::textColor),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void text(const string& in)",
            asFUNCTION(text),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void drawIcon(const string& in, int)",
            asFUNCTION(Deer::EditorEngine::drawIcon),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "bool isMouseClicked(int)",
            asFUNCTION(
                isMouseClicked
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "bool isMouseDoubleClicked(int)",
            asFUNCTION(
                isMouseDoubleClicked
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void setupAutomaticColumns(int)",
            asFUNCTION(
                setupAutomaticColumns
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void endColumns()",
            asFUNCTION(endColumns),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void nextColumn()",
            asFUNCTION(nextColumn),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void print(const string& in)",
            asFUNCTION (Deer::EditorEngine::print),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void textCentered(const string& in)",
            asFUNCTION(Deer::EditorEngine::textCentered),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void drawIconCentered(const string& in, int)",
            asFUNCTION(Deer::EditorEngine::drawIconCentered),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "int getResourceCount(ResourceType, const string& in)",
            asFUNCTION(Deer::EditorEngine::getResourceCount),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getResourceNameById(ResourceType, const string& in, int)",
            asFUNCTION(Deer::EditorEngine::getResourceNameById),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getResourcePathById(ResourceType, const string& in, int)",
            asFUNCTION(Deer::EditorEngine::getResourcePathById),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "int getDirCount(ResourceType, const string& in)",
            asFUNCTION(Deer::EditorEngine::getDirCount),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getDirPathById(ResourceType, const string& in, int)",
            asFUNCTION(Deer::EditorEngine::getDirPathById),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getDirNameById(ResourceType, const string& in, int)",
            asFUNCTION(Deer::EditorEngine::getDirNameById),
            asCALL_CDECL
        ));
    }
}